VisimBox 1.0 VisimBox 3d simulation and visualisation ToolBox

- Main Page
- Packages
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Properties | Events
VisimBox.Renderer.IRenderContext Interface Reference
Inheritance diagram for VisimBox.Renderer.IRenderContext:

List of all members.

## Public Member Functions
ICamera | CreateDefaultCamera ()
| Creates default camera.
System.Drawing.Bitmap | GetScreenShot ()
| Grabs actual content of the render context and converts it to bitmap.
void | SaveScreenShot (string filename=null, string extension=null)
| Saves screenshot with specified name, uses GetScreenShot()
void | RenderFrame ()
| Renders frame in standard way (StartFrame and then EndFrame with associated callbacks)
void | StartFrame ()
| Starts rendering frame.
void | EndFrame ()
| Finished rendering frame and shows it.
void | RenderNodes (Node scene)
| Renders spefified node hierarchy.
void | AddRenderItem (RenderBufferItem item)
| Adds render item to the renderer queue.
void | ClearRenderingQueue ()
| Clears rendering queue.
void | StartRenderingQueue ()
| Starts rendering queue (allows adding new items to render queue. If renderer uses multithreading, queue will be rendered as soon as some queue item will be added, except alpha values.
void | FinishRenderQueue ()
| Finishes rendering queue (renders all remaining items in the queue including sorted alpha items)
void | SetColor (ColorByte col)
| Sets main rendering color (especially for 2d rendering)
void | SetColor (ref ColorByte col)
| Sets main rendering color (especially for 2d rendering)
void | SetColor (System.Drawing.Color col)
| Sets main rendering color (especially for 2d rendering)
void | SetTransformation (ref Matrix4 mat)
| Sets model transformation (without camera transformation)
void | SetTransformation (Matrix4 mat)
| Sets model transformation (without camera transformation)
void | DrawPoint3D (IVertex point)
| Draws one vertex as a point.
void | DrawPoint3D (ref Vector3 vec)
| Draws one vector as a point.
void | DrawPoint3D (Vector3 vec)
| Draws one vector as a point.
void | DrawLine3D (IVertex first, IVertex second)
| Draws single line from first to second.
void | DrawLine3D (ref Vector3 first, ref Vector3 second)
| Draws single line from first to second.
void | DrawLine3D (Vector3 first, Vector3 second)
| Draws single line from first to second.
void | DrawTriangle3D (IVertex first, IVertex second, IVertex third)
| Draws single triangle specified by three vertices.
void | DrawTriangle3D (ref Vector3 first, ref Vector3 second, ref Vector3 third)
| Draws single triangle specified by three vertices.
void | DrawTriangle3D (Vector3 first, Vector3 second, Vector3 third)
| Draws single triangle specified by three vertices.
void | DrawQuad3D (IVertex first, IVertex second, IVertex third, IVertex fourth)
| Draws single quad specified by four vertices.
void | DrawQuad3D (ref Vector3 first, ref Vector3 second, ref Vector3 third, ref Vector3 fourth)
| Draws single quad specified by four vertices.
void | DrawQuad3D (Vector3 first, Vector3 second, Vector3 third, Vector3 fourth)
| Draws single quad specified by four vertices.
void | RenderPoints (IVertexArray varray, int startindex=0, int count=0)
| Renders points from vertex array.
void | RenderLines (IVertexArray varray, int startindex=0, int count=0)
| Renders lines from vertex array.
void | RenderLine (IVertexArray varray, int startindex=0, int count=0)
| Renders polyline from vertex array.
void | RenderTriangles (IVertexArray varray, int startindex=0, int count=0)
| Renders triangles from vertex array.
void | RenderQuads (IVertexArray varray, int startindex=0, int count=0)
| Renders quads from vertex array.
void | RenderPoly (IVertexArray varray, int startindex=0, int count=0)
| Renders polygon from vertex array.
void | RenderIndexedMesh (IVertexArray varray, int[] indices, PrimitiveTypes type, int startindex=0, int count=0)
| Renders indexed mesh from vertex array.
void | RenderGeometry (Point3DList geo)
| Renders geometry object - List of points.
void | RenderGeometry (LineList geo)
| Renders geometry object - List of lines.
void | RenderGeometry (PolyLine geo)
| Renders geometry object - PolyLine.
void | RenderGeometry (TriangleList geo)
| Renders geometry object - List of triangles.
void | RenderGeometry (QuadList geo)
| Renders geometry object - List of quads.
void | RenderGeometry (IndexedGeo geo, int subset=0)
| Renders geometry object - generic indexed geometry.
void | RenderGeometry (IndexedMesh geo, int subset=0)
| Renders geometry object - Indexed triangle mesh.
void | RenderGeometry (IndexedQuads geo, int subset=0)
| Renders geometry object - Indexed quad mesh.
void | RenderGeometry (IndexedLines geo, int subset=0)
| Renders geometry object - Indexed list of points.
void | RenderGeometry (IGeometry geometry)
| Renders generic geometry object - uses conversion routines from the object, will be very slow if overused!
void | RenderVertexBuffer (IVertexBuffer vertices, PrimitiveTypes type, int startindex=0, int count=0)
| Render vertex buffer as specified type of primitive (can't be used for indexed meshes!)
void | RenderIndexedMesh (IVertexBuffer vertices, int[] indices, PrimitiveTypes type, int startindex=0, int count=0)
| Renders indexed mesh from vertex and index buffer.
void | RenderIndexedMesh (IVertexBuffer vertices, IIndexBuffer indices, PrimitiveTypes type, int startindex=0, int count=0)
| Renders indexed mesh from vertex and index buffer.
void | DrawSkybox (ref SkyboxData skybox)
| Draws simple skybox.
void | Start2DRender ()
| Sets renderer to 2d context, all 2d rendering calls should be done after this call!
void | Stop2DRender ()
| Returns renderer to previous (3d) rendering state from the 2d renderer.
void | DrawPoint (int x, int y)
| Draw point in screen coordinates with currently selected color.
void | DrawPoint (int x, int y, ColorByte Color)
void | DrawPoint (int x, int y, System.Drawing.Color Color)
| Draw point in screen coordinates.
void | DrawLine (int x1, int y1, int x2, int y2)
| Draw line in screen coordinates with currently selected color.
void | DrawLine (int x1, int y1, int x2, int y2, ColorByte Color)
void | DrawLine (int x1, int y1, int x2, int y2, System.Drawing.Color Color)
| Draw line in screen coordinates.
void | DrawRectangle (int x1, int y1, int width, int height)
| Draws outlined 2d rectangle with x1 and y1 coordinates of top left and width and height, using current color.
void | DrawRectangle (int x1, int y1, int width, int height, ColorByte color)
| Draws outlined 2d rectangle with x1 and y1 coordinates of top left and width and height.
void | DrawRectangle (int x1, int y1, int width, int height, System.Drawing.Color color)
| Draws outlined 2d rectangle with x1 and y1 coordinates of top left and width and height.
void | DrawRectangle (System.Drawing.Rectangle rect)
| Draws outlined 2d rectangle with current color.
void | DrawRectangle (System.Drawing.Rectangle rect, ColorByte Color)
| Draws outlined 2d rectangle.
void | DrawRectangle (System.Drawing.Rectangle rect, System.Drawing.Color Color)
| Draws outlined 2d rectangle.
void | DrawFilledRectangle (int x1, int y1, int width, int height)
| Draws filled 2d rectangle with x1 and y1 coordinates of top left and width and height, using current color.
void | DrawFilledRectangle (int x1, int y1, int width, int height, ColorByte color)
| Draws filled 2d rectangle with x1 and y1 coordinates of top left and width and height.
void | DrawFilledRectangle (int x1, int y1, int width, int height, System.Drawing.Color color)
| Draws filled 2d rectangle with x1 and y1 coordinates of top left and width and height.
void | DrawFilledRectangle (System.Drawing.Rectangle rect)
| Draws filled 2d rectangle with current color.
void | DrawFilledRectangle (System.Drawing.Rectangle rect, ColorByte Color)
| Draws filled 2d rectangle.
void | DrawFilledRectangle (System.Drawing.Rectangle rect, System.Drawing.Color Color)
| Draws filled 2d rectangle.
void | ChangeFont (string fontname)
| Changes current font of the context to specified font (from font manager)
void | ChangeFont (Render2D.Font font)
| Changes current font of the context to the font.
void | DrawText (int x, int y, string text)
| Simple text drawing on selected coordinate. Uses currently selected font.
void | DrawText (int x, int y, string text, ColorByte color)
| Simple text drawing on selected coordinate. Uses currently selected font.
void | DrawText (int x, int y, string text, System.Drawing.Color color)
| Simple text drawing on selected coordinate. Uses currently selected font.
void | DrawText (int x, int y, int maxwidth, int maxheight, string text)
| Draw text on selected coordinate with specified max size of the text block. Uses currently selected font.
void | DrawText (int x, int y, int maxwidth, int maxheight, string text, ColorByte color)
| Draw text on selected coordinate with specified max size of the text block. Uses currently selected font.
void | DrawText (int x, int y, int maxwidth, int maxheight, string text, System.Drawing.Color color)
| Draw text on selected coordinate with specified max size of the text block. Uses currently selected font.
void | DrawText (System.Drawing.Rectangle rect, string text)
| Draw text on selected coordinate with specified max size of the text block. Uses currently selected font.
void | DrawText (System.Drawing.Rectangle rect, string text, ColorByte color)
| Draw text on selected coordinate with specified max size of the text block. Uses currently selected font.
void | DrawText (System.Drawing.Rectangle rect, string text, System.Drawing.Color color)
| Draw text on selected coordinate with specified max size of the text block. Uses currently selected font.
void | DrawImage (int x, int y)
| Draws currently selected texture in real size to specified place on screen. NOTE - uses current color, don't forget to set it to white unless you want colored image.
void | DrawImage (int x, int y, string texture)
| Draws selected texture in real size to specified place on screen. NOTE - uses current color, don't forget to set it to white unless you want colored image.
void | DrawImage (int x, int y, Texture tex)
| Draws selected texture in real size to specified place on screen. NOTE - uses current color, don't forget to set it to white unless you want colored image.
void | DrawImage (int x, int y, int width, int height)
| Draws currently selected texture scaled to specified width and height.
void | DrawImage (int x, int y, int width, int height, string texture)
| Draws selected texture scaled to specified width and height.
void | DrawImage (int x, int y, int width, int height, Texture tex)
| Draws selected texture scaled to specified width and height.
void | DrawImage (System.Drawing.Rectangle rect)
| Draws currently selected texture scaled to specified rectangle.
void | DrawImage (System.Drawing.Rectangle rect, string texture)
| Draws currently selected texture scaled to specified rectangle.
void | DrawImage (System.Drawing.Rectangle rect, Texture tex)
| Draws currently selected texture scaled to specified rectangle.
void | DrawImagePart (int x, int y, int sourcex, int sourcey, int sourcewidth, int sourceheight)
| Draws unscaled part of the currently selected texture on the screen.
void | DrawImagePart (int x, int y, int sourcex, int sourcey, int sourcewidth, int sourceheight, string texture)
| Draws unscaled part of the selected texture on the screen.
void | DrawImagePart (int x, int y, int sourcex, int sourcey, int sourcewidth, int sourceheight, Texture tex)
| Draws unscaled part of the selected texture on the screen.
void | DrawImagePart (int x, int y, System.Drawing.Rectangle source)
| Draws unscaled part of the currently selected texture on the screen.
void | DrawImagePart (int x, int y, System.Drawing.Rectangle source, string texture)
| Draws unscaled part of the selected texture on the screen.
void | DrawImagePart (int x, int y, System.Drawing.Rectangle source, Texture tex)
| Draws unscaled part of the selected texture on the screen.
void | DrawImagePart (int x, int y, int width, int height, int sourcex, int sourcey, int sourcewidth, int sourceheight)
| Draws scaled part of the currently selected texture on the screen.
void | DrawImagePart (int x, int y, int width, int height, int sourcex, int sourcey, int sourcewidth, int sourceheight, string texture)
| Draws scaled part of the selected texture on the screen.
void | DrawImagePart (int x, int y, int width, int height, int sourcex, int sourcey, int sourcewidth, int sourceheight, Texture tex)
| Draws scaled part of the selected texture on the screen.
void | DrawImagePart (System.Drawing.Rectangle target, System.Drawing.Rectangle source)
| Draws scaled part of the currently selected texture on the screen.
void | DrawImagePart (System.Drawing.Rectangle target, System.Drawing.Rectangle source, string texture)
| Draws scaled part of the selected texture on the screen.
void | DrawImagePart (System.Drawing.Rectangle target, System.Drawing.Rectangle source, Texture tex)
| Draws scaled part of the selected texture on the screen.
void | DrawSprite (int x, int y, Render2D.SpriteInfo sprite)
| Draws sprite with currently selected texture.
void | DrawSprite (int x, int y, ref Render2D.SpriteInfo sprite)
| Draws sprite with currently selected texture.
void | DrawSprite (int x, int y, Render2D.SpriteInfo sprite, string texture)
| Draws sprite with currently selected texture.
void | DrawSprite (int x, int y, Render2D.SpriteInfo sprite, Texture tex)
| Draws sprite with currently selected texture.
void | DrawSprites (int x, int y, Render2D.SpriteInfo[] sprites)
| Draws array of sprites with currently selected texture.
void | DrawSprites (int x, int y, Render2D.SpriteInfo[] sprites, string texture)
| Draws array of sprites with currently selected texture.
void | DrawSprites (int x, int y, Render2D.SpriteInfo[] sprites, Texture tex)
| Draws array of sprites with currently selected texture.
void | DrawSprites (int x, int y, Render2D.SpriteBatch sprites)
| Draws batch of sprites.
void | DrawSprites (int x, int y, ref Render2D.SpriteBatch sprites)
| Draws batch of sprites.
## Properties
RenderContextSettings | Settings`[get]`
| Settings of the context.
IRenderer | Renderer`[get]`
| Main renderer for this context.
int | CurrentFPS`[get]`
| Returns current rendering frames per second for this context.
bool | ShowFPS`[get, set]`
| Show fps on screen?
ICamera | MainCamera`[get, set]`
| Returns pointer to the main camera (camera in main viewport)
Texture | CurrentTexture`[get, set]`
| Currently selected texture.
Vector3 | DebugPoint`[get, set]`
Vector3 | DebugLine1`[get, set]`
Vector3 | DebugLine2`[get, set]`
bool | Fog`[get, set]`
| Enables / disables fog drawing.
ColorByte | FogColor`[get, set]`
| Color of the fog.
float | FogDensity`[get, set]`
| Density of the fog.
bool | ZBufferUsing`[get, set]`
| Use to directly change using of the zbuffer.
## Events
RendererEvent | FrameStart
| Called on the framestart before any rendering / clearing starts.
RendererEvent | FrameEnd
| Called on the end of the frame before showing results of the rendering.

## Member Function Documentation

void VisimBox.Renderer.IRenderContext.AddRenderItem | ( | RenderBufferItem | item | ) |

Adds render item to the renderer queue.

Parameters:

  item | Render buffer item

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.ChangeFont | ( | string | fontname | ) |

Changes current font of the context to specified font (from font manager)

Parameters:

  fontname | Name of the font in the font manager

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.ChangeFont | ( | Render2D.Font | font | ) |

Changes current font of the context to the font.

Parameters:

  font | Rendering font

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.ClearRenderingQueue | ( |  | ) |

Clears rendering queue.

Implemented in VisimBox.Renderer.RenderContext.

ICamera VisimBox.Renderer.IRenderContext.CreateDefaultCamera | ( |  | ) |

Creates default camera.

Returns:
  New default camera

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawFilledRectangle | ( | int | x1,
|  | int | y1,
|  | int | width,
|  | int | height,
|  | ColorByte | color
| ) |  |

Draws filled 2d rectangle with x1 and y1 coordinates of top left and width and height.

Parameters:

  x1 | left upper corner
  y1 | left upper corner
  width | width
  height | height
  color | Color of the outline

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawFilledRectangle | ( | int | x1,
|  | int | y1,
|  | int | width,
|  | int | height,
|  | System.Drawing.Color | color
| ) |  |

Draws filled 2d rectangle with x1 and y1 coordinates of top left and width and height.

Parameters:

  x1 | left upper corner
  y1 | left upper corner
  width | width
  height | height
  color | Color of the outline

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawFilledRectangle | ( | System.Drawing.Rectangle | rect | ) |

Draws filled 2d rectangle with current color.

Parameters:

  rect | Rectangle

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawFilledRectangle | ( | System.Drawing.Rectangle | rect,
|  | System.Drawing.Color | Color
| ) |  |

Draws filled 2d rectangle.

Parameters:

  Color | Color of the outline
  rect | Rectangle

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawFilledRectangle | ( | int | x1,
|  | int | y1,
|  | int | width,
|  | int | height
| ) |  |

Draws filled 2d rectangle with x1 and y1 coordinates of top left and width and height, using current color.

Parameters:

  x1 | left upper corner
  y1 | left upper corner
  width | width
  height | height

Implemented in VisimBox.Renderer.RenderContext, and VisimRenderGL.GLRenderContext.

void VisimBox.Renderer.IRenderContext.DrawFilledRectangle | ( | System.Drawing.Rectangle | rect,
|  | ColorByte | Color
| ) |  |

Draws filled 2d rectangle.

Parameters:

  Color | Color of the outline
  rect | Rectangle

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawImage | ( | int | x,
|  | int | y
| ) |  |

Draws currently selected texture in real size to specified place on screen. NOTE - uses current color, don't forget to set it to white unless you want colored image.

Parameters:

  x | X coordinate of top left corner
  y | Y coordinate of top left corner

Implemented in VisimBox.Renderer.RenderContext, and VisimRenderGL.GLRenderContext.

void VisimBox.Renderer.IRenderContext.DrawImage | ( | int | x,
|  | int | y,
|  | string | texture
| ) |  |

Draws selected texture in real size to specified place on screen. NOTE - uses current color, don't forget to set it to white unless you want colored image.

Parameters:

  x | X coordinate of top left corner
  y | Y coordinate of top left corner
  texture | Name of the texture in the texture manager

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawImage | ( | int | x,
|  | int | y,
|  | Texture | tex
| ) |  |

Draws selected texture in real size to specified place on screen. NOTE - uses current color, don't forget to set it to white unless you want colored image.

Parameters:

  x | X coordinate of top left corner
  y | Y coordinate of top left corner
  tex | Texture to be set

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawImage | ( | int | x,
|  | int | y,
|  | int | width,
|  | int | height
| ) |  |

Draws currently selected texture scaled to specified width and height.

Parameters:

  x | X coordinate of top left corner
  y | Y coordinate of top left corner
  width | Width of the drawn image
  height | Height of the drawn image

Implemented in VisimBox.Renderer.RenderContext, and VisimRenderGL.GLRenderContext.

void VisimBox.Renderer.IRenderContext.DrawImage | ( | int | x,
|  | int | y,
|  | int | width,
|  | int | height,
|  | string | texture
| ) |  |

Draws selected texture scaled to specified width and height.

Parameters:

  x | X coordinate of top left corner
  y | Y coordinate of top left corner
  width | Width of the drawn image
  height | Height of the drawn image
  texture | Name of the texture in the texture manager

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawImage | ( | int | x,
|  | int | y,
|  | int | width,
|  | int | height,
|  | Texture | tex
| ) |  |

Draws selected texture scaled to specified width and height.

Parameters:

  x | X coordinate of top left corner
  y | Y coordinate of top left corner
  width | Width of the drawn image
  height | Height of the drawn image
  tex | Texture to be set

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawImage | ( | System.Drawing.Rectangle | rect | ) |

Draws currently selected texture scaled to specified rectangle.

Parameters:

  rect | Rectangle on screen

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawImage | ( | System.Drawing.Rectangle | rect,
|  | string | texture
| ) |  |

Draws currently selected texture scaled to specified rectangle.

Parameters:

  rect | Rectangle on screen
  texture | Name of the texture in the texture manager

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawImage | ( | System.Drawing.Rectangle | rect,
|  | Texture | tex
| ) |  |

Draws currently selected texture scaled to specified rectangle.

Parameters:

  rect | Rectangle on screen
  tex | Texture to be set

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawImagePart | ( | int | x,
|  | int | y,
|  | System.Drawing.Rectangle | source,
|  | Texture | tex
| ) |  |

Draws unscaled part of the selected texture on the screen.

Parameters:

  x | X coordinate of top left corner
  y | Y coordinate of top left corner
  source | Source rectangle in the texture
  tex | Texture to be set

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawImagePart | ( | int | x,
|  | int | y,
|  | int | sourcex,
|  | int | sourcey,
|  | int | sourcewidth,
|  | int | sourceheight
| ) |  |

Draws unscaled part of the currently selected texture on the screen.

Parameters:

  x | X coordinate of top left corner
  y | Y coordinate of top left corner
  sourcex | X coordinate of top left corner inside the texture
  sourcey | Y coordinate of top left corner inside the texture
  sourcewidth | Width of the texture part
  sourceheight | Height of the texture part

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawImagePart | ( | int | x,
|  | int | y,
|  | int | sourcex,
|  | int | sourcey,
|  | int | sourcewidth,
|  | int | sourceheight,
|  | string | texture
| ) |  |

Draws unscaled part of the selected texture on the screen.

Parameters:

  x | X coordinate of top left corner
  y | Y coordinate of top left corner
  sourcex | X coordinate of top left corner inside the texture
  sourcey | Y coordinate of top left corner inside the texture
  sourcewidth | Width of the texture part
  sourceheight | Height of the texture part
  texture | Name of the texture in the texture manager

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawImagePart | ( | int | x,
|  | int | y,
|  | int | sourcex,
|  | int | sourcey,
|  | int | sourcewidth,
|  | int | sourceheight,
|  | Texture | tex
| ) |  |

Draws unscaled part of the selected texture on the screen.

Parameters:

  x | X coordinate of top left corner
  y | Y coordinate of top left corner
  sourcex | X coordinate of top left corner inside the texture
  sourcey | Y coordinate of top left corner inside the texture
  sourcewidth | Width of the texture part
  sourceheight | Height of the texture part
  tex | Texture to be set

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawImagePart | ( | int | x,
|  | int | y,
|  | System.Drawing.Rectangle | source
| ) |  |

Draws unscaled part of the currently selected texture on the screen.

Parameters:

  x | X coordinate of top left corner
  y | Y coordinate of top left corner
  source | Source rectangle in the texture

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawImagePart | ( | int | x,
|  | int | y,
|  | System.Drawing.Rectangle | source,
|  | string | texture
| ) |  |

Draws unscaled part of the selected texture on the screen.

Parameters:

  x | X coordinate of top left corner
  y | Y coordinate of top left corner
  source | Source rectangle in the texture
  texture | Name of the texture in the texture manager

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawImagePart | ( | int | x,
|  | int | y,
|  | int | width,
|  | int | height,
|  | int | sourcex,
|  | int | sourcey,
|  | int | sourcewidth,
|  | int | sourceheight
| ) |  |

Draws scaled part of the currently selected texture on the screen.

Parameters:

  x | X coordinate of top left corner
  y | Y coordinate of top left corner
  width | Width of the drawn image
  height | Height of the drawn image
  sourcex | X coordinate of top left corner inside the texture
  sourcey | Y coordinate of top left corner inside the texture
  sourcewidth | Width of the texture part
  sourceheight | Height of the texture part

Implemented in VisimBox.Renderer.RenderContext, and VisimRenderGL.GLRenderContext.

void VisimBox.Renderer.IRenderContext.DrawImagePart | ( | int | x,
|  | int | y,
|  | int | width,
|  | int | height,
|  | int | sourcex,
|  | int | sourcey,
|  | int | sourcewidth,
|  | int | sourceheight,
|  | string | texture
| ) |  |

Draws scaled part of the selected texture on the screen.

Parameters:

  x | X coordinate of top left corner
  y | Y coordinate of top left corner
  width | Width of the drawn image
  height | Height of the drawn image
  sourcex | X coordinate of top left corner inside the texture
  sourcey | Y coordinate of top left corner inside the texture
  sourcewidth | Width of the texture part
  sourceheight | Height of the texture part
  texture | Name of the texture in the texture manager

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawImagePart | ( | int | x,
|  | int | y,
|  | int | width,
|  | int | height,
|  | int | sourcex,
|  | int | sourcey,
|  | int | sourcewidth,
|  | int | sourceheight,
|  | Texture | tex
| ) |  |

Draws scaled part of the selected texture on the screen.

Parameters:

  x | X coordinate of top left corner
  y | Y coordinate of top left corner
  width | Width of the drawn image
  height | Height of the drawn image
  sourcex | X coordinate of top left corner inside the texture
  sourcey | Y coordinate of top left corner inside the texture
  sourcewidth | Width of the texture part
  sourceheight | Height of the texture part
  tex | Texture to be set

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawImagePart | ( | System.Drawing.Rectangle | target,
|  | System.Drawing.Rectangle | source
| ) |  |

Draws scaled part of the currently selected texture on the screen.

Parameters:

  target | Target rectangle on the screen
  source | Source rectangle in the texture

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawImagePart | ( | System.Drawing.Rectangle | target,
|  | System.Drawing.Rectangle | source,
|  | string | texture
| ) |  |

Draws scaled part of the selected texture on the screen.

Parameters:

  target | Target rectangle on the screen
  source | Source rectangle in the texture
  texture | Name of the texture in the texture manager

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawImagePart | ( | System.Drawing.Rectangle | target,
|  | System.Drawing.Rectangle | source,
|  | Texture | tex
| ) |  |

Draws scaled part of the selected texture on the screen.

Parameters:

  target | Target rectangle on the screen
  source | Source rectangle in the texture
  tex | Texture to be set

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawLine | ( | int | x1,
|  | int | y1,
|  | int | x2,
|  | int | y2
| ) |  |

Draw line in screen coordinates with currently selected color.

Parameters:

  x1 | x of the start of the line
  y1 | y of the start of the line
  x2 | X of the end of the line
  y2 | y of the end of the line

Implemented in VisimBox.Renderer.RenderContext, and VisimRenderGL.GLRenderContext.

void VisimBox.Renderer.IRenderContext.DrawLine | ( | int | x1,
|  | int | y1,
|  | int | x2,
|  | int | y2,
|  | ColorByte | Color
| ) |  |

Draw line in screen coordinates

Parameters:

  x1 | x of the start of the line
  y1 | y of the start of the line
  x2 | X of the end of the line
  y2 | y of the end of the line
  Color | Color of the line

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawLine | ( | int | x1,
|  | int | y1,
|  | int | x2,
|  | int | y2,
|  | System.Drawing.Color | Color
| ) |  |

Draw line in screen coordinates.

Parameters:

  x1 | x of the start of the line
  y1 | y of the start of the line
  x2 | X of the end of the line
  y2 | y of the end of the line
  Color | Color of the line

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawLine3D | ( | IVertex | first,
|  | IVertex | second
| ) |  |

Draws single line from first to second.

This is slow, use only in special circumstances (debug rendering)

Implemented in VisimBox.Renderer.RenderContext, and VisimRenderGL.GLRenderContext.

void VisimBox.Renderer.IRenderContext.DrawLine3D | ( | ref Vector3 | first,
|  | ref Vector3 | second
| ) |  |

Draws single line from first to second.

This is slow, use only in special circumstances (debug rendering)

Implemented in VisimBox.Renderer.RenderContext, and VisimRenderGL.GLRenderContext.

void VisimBox.Renderer.IRenderContext.DrawLine3D | ( | Vector3 | first,
|  | Vector3 | second
| ) |  |

Draws single line from first to second.

This is slow, use only in special circumstances (debug rendering)

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawPoint | ( | int | x,
|  | int | y
| ) |  |

Draw point in screen coordinates with currently selected color.

Parameters:

  x | X position
  y | Y position

Implemented in VisimBox.Renderer.RenderContext, and VisimRenderGL.GLRenderContext.

void VisimBox.Renderer.IRenderContext.DrawPoint | ( | int | x,
|  | int | y,
|  | ColorByte | Color
| ) |  |

Draw point in screen coordinates

Parameters:

  x | X position
  y | Y position
  Color | Color of the pixel

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawPoint | ( | int | x,
|  | int | y,
|  | System.Drawing.Color | Color
| ) |  |

Draw point in screen coordinates.

Parameters:

  x | X position
  y | Y position
  Color | Color of the pixel

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawPoint3D | ( | IVertex | point | ) |

Draws one vertex as a point.

This is slow, use only in special circumstances (debug rendering)

Implemented in VisimBox.Renderer.RenderContext, and VisimRenderGL.GLRenderContext.

void VisimBox.Renderer.IRenderContext.DrawPoint3D | ( | ref Vector3 | vec | ) |

Draws one vector as a point.

This is slow, use only in special circumstances (debug rendering)

Implemented in VisimBox.Renderer.RenderContext, and VisimRenderGL.GLRenderContext.

void VisimBox.Renderer.IRenderContext.DrawPoint3D | ( | Vector3 | vec | ) |

Draws one vector as a point.

This is slow, use only in special circumstances (debug rendering)

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawQuad3D | ( | ref Vector3 | first,
|  | ref Vector3 | second,
|  | ref Vector3 | third,
|  | ref Vector3 | fourth
| ) |  |

Draws single quad specified by four vertices.

Implemented in VisimBox.Renderer.RenderContext, and VisimRenderGL.GLRenderContext.

void VisimBox.Renderer.IRenderContext.DrawQuad3D | ( | IVertex | first,
|  | IVertex | second,
|  | IVertex | third,
|  | IVertex | fourth
| ) |  |

Draws single quad specified by four vertices.

This is slow, use only in special circumstances (debug rendering)

Implemented in VisimBox.Renderer.RenderContext, and VisimRenderGL.GLRenderContext.

void VisimBox.Renderer.IRenderContext.DrawQuad3D | ( | Vector3 | first,
|  | Vector3 | second,
|  | Vector3 | third,
|  | Vector3 | fourth
| ) |  |

Draws single quad specified by four vertices.

This is slow, use only in special circumstances (debug rendering)

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawRectangle | ( | int | x1,
|  | int | y1,
|  | int | width,
|  | int | height
| ) |  |

Draws outlined 2d rectangle with x1 and y1 coordinates of top left and width and height, using current color.

Parameters:

  x1 | left upper corner
  y1 | left upper corner
  width | width
  height | height

Implemented in VisimBox.Renderer.RenderContext, and VisimRenderGL.GLRenderContext.

void VisimBox.Renderer.IRenderContext.DrawRectangle | ( | System.Drawing.Rectangle | rect,
|  | System.Drawing.Color | Color
| ) |  |

Draws outlined 2d rectangle.

Parameters:

  Color | Color of the outline
  rect | Rectangle

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawRectangle | ( | int | x1,
|  | int | y1,
|  | int | width,
|  | int | height,
|  | ColorByte | color
| ) |  |

Draws outlined 2d rectangle with x1 and y1 coordinates of top left and width and height.

Parameters:

  x1 | left upper corner
  y1 | left upper corner
  width | width
  height | height
  color | Color of the outline

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawRectangle | ( | int | x1,
|  | int | y1,
|  | int | width,
|  | int | height,
|  | System.Drawing.Color | color
| ) |  |

Draws outlined 2d rectangle with x1 and y1 coordinates of top left and width and height.

Parameters:

  x1 | left upper corner
  y1 | left upper corner
  width | width
  height | height
  color | Color of the outline

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawRectangle | ( | System.Drawing.Rectangle | rect | ) |

Draws outlined 2d rectangle with current color.

Parameters:

  rect | Rectangle

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawRectangle | ( | System.Drawing.Rectangle | rect,
|  | ColorByte | Color
| ) |  |

Draws outlined 2d rectangle.

Parameters:

  Color | Color of the outline
  rect | Rectangle

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawSkybox | ( | ref SkyboxData | skybox | ) |

Draws simple skybox.

Parameters:

  skybox | Skybox data (note, textures in skybox must be initialized!)

Implemented in VisimBox.Renderer.RenderContext, and VisimRenderGL.GLRenderContext.

void VisimBox.Renderer.IRenderContext.DrawSprite | ( | int | x,
|  | int | y,
|  | ref Render2D.SpriteInfo | sprite
| ) |  |

Draws sprite with currently selected texture.

Parameters:

  x | X position (screen coords) for the sprite
  y | Y position (screen coords) for the sprite
  sprite | Sprite information

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawSprite | ( | int | x,
|  | int | y,
|  | Render2D.SpriteInfo | sprite,
|  | Texture | tex
| ) |  |

Draws sprite with currently selected texture.

Parameters:

  x | X position (screen coords) for the sprite
  y | Y position (screen coords) for the sprite
  tex | Texture to be set
  sprite | Sprite information

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawSprite | ( | int | x,
|  | int | y,
|  | Render2D.SpriteInfo | sprite
| ) |  |

Draws sprite with currently selected texture.

Parameters:

  x | X position (screen coords) for the sprite
  y | Y position (screen coords) for the sprite
  sprite | Sprite information

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawSprite | ( | int | x,
|  | int | y,
|  | Render2D.SpriteInfo | sprite,
|  | string | texture
| ) |  |

Draws sprite with currently selected texture.

Parameters:

  x | X position (screen coords) for the sprite
  y | Y position (screen coords) for the sprite
  texture | Texture name
  sprite | Sprite information

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawSprites | ( | int | x,
|  | int | y,
|  | Render2D.SpriteInfo[] | sprites,
|  | string | texture
| ) |  |

Draws array of sprites with currently selected texture.

Parameters:

  x | X position (screen coords) for the sprite
  y | Y position (screen coords) for the sprite
  sprites | Sprite information
  texture | Texture name

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawSprites | ( | int | x,
|  | int | y,
|  | Render2D.SpriteBatch | sprites
| ) |  |

Draws batch of sprites.

Parameters:

  x | X position (screen coords) for the sprite
  y | Y position (screen coords) for the sprite
  sprites | SpriteBatch (should contain valid texture!)

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawSprites | ( | int | x,
|  | int | y,
|  | ref Render2D.SpriteBatch | sprites
| ) |  |

Draws batch of sprites.

Parameters:

  x | X position (screen coords) for the sprite
  y | Y position (screen coords) for the sprite
  sprites | SpriteBatch (should contain valid texture!)

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawSprites | ( | int | x,
|  | int | y,
|  | Render2D.SpriteInfo[] | sprites
| ) |  |

Draws array of sprites with currently selected texture.

Parameters:

  x | X position (screen coords) for the sprite
  y | Y position (screen coords) for the sprite
  sprites | Sprite information

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawSprites | ( | int | x,
|  | int | y,
|  | Render2D.SpriteInfo[] | sprites,
|  | Texture | tex
| ) |  |

Draws array of sprites with currently selected texture.

Parameters:

  x | X position (screen coords) for the sprite
  y | Y position (screen coords) for the sprite
  tex | Texture to be set
  sprites | Sprite information

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawText | ( | int | x,
|  | int | y,
|  | string | text
| ) |  |

Simple text drawing on selected coordinate. Uses currently selected font.

Parameters:

  x | X coordinate
  y | Y coordinate
  text | text

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawText | ( | int | x,
|  | int | y,
|  | string | text,
|  | ColorByte | color
| ) |  |

Simple text drawing on selected coordinate. Uses currently selected font.

Parameters:

  x | X coordinate
  y | Y coordinate
  text | text
  color | Color of the text

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawText | ( | int | x,
|  | int | y,
|  | string | text,
|  | System.Drawing.Color | color
| ) |  |

Simple text drawing on selected coordinate. Uses currently selected font.

Parameters:

  x | X coordinate
  y | Y coordinate
  text | text
  color | Color of the text

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawText | ( | int | x,
|  | int | y,
|  | int | maxwidth,
|  | int | maxheight,
|  | string | text,
|  | ColorByte | color
| ) |  |

Draw text on selected coordinate with specified max size of the text block. Uses currently selected font.

Parameters:

  x | X coordinate
  y | Y coordinate
  maxheight | Maximal height of the text block
  maxwidth | Maximal width of the text block
  text | text
  color | Color of the text

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawText | ( | System.Drawing.Rectangle | rect,
|  | string | text
| ) |  |

Draw text on selected coordinate with specified max size of the text block. Uses currently selected font.

Parameters:

  rect | Rectangle to write text to
  text | text

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawText | ( | int | x,
|  | int | y,
|  | int | maxwidth,
|  | int | maxheight,
|  | string | text
| ) |  |

Draw text on selected coordinate with specified max size of the text block. Uses currently selected font.

Parameters:

  x | X coordinate
  y | Y coordinate
  maxheight | Maximal height of the text block
  maxwidth | Maximal width of the text block
  text | text

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawText | ( | System.Drawing.Rectangle | rect,
|  | string | text,
|  | System.Drawing.Color | color
| ) |  |

Draw text on selected coordinate with specified max size of the text block. Uses currently selected font.

Parameters:

  rect | Rectangle to write text to
  text | text
  color | Color of the text

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawText | ( | int | x,
|  | int | y,
|  | int | maxwidth,
|  | int | maxheight,
|  | string | text,
|  | System.Drawing.Color | color
| ) |  |

Draw text on selected coordinate with specified max size of the text block. Uses currently selected font.

Parameters:

  x | X coordinate
  y | Y coordinate
  maxheight | Maximal height of the text block
  maxwidth | Maximal width of the text block
  text | text
  color | Color of the text

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawText | ( | System.Drawing.Rectangle | rect,
|  | string | text,
|  | ColorByte | color
| ) |  |

Draw text on selected coordinate with specified max size of the text block. Uses currently selected font.

Parameters:

  rect | Rectangle to write text to
  text | text
  color | Color of the text

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawTriangle3D | ( | Vector3 | first,
|  | Vector3 | second,
|  | Vector3 | third
| ) |  |

Draws single triangle specified by three vertices.

This is slow, use only in special circumstances (debug rendering)

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.DrawTriangle3D | ( | ref Vector3 | first,
|  | ref Vector3 | second,
|  | ref Vector3 | third
| ) |  |

Draws single triangle specified by three vertices.

This is slow, use only in special circumstances (debug rendering)

Implemented in VisimBox.Renderer.RenderContext, and VisimRenderGL.GLRenderContext.

void VisimBox.Renderer.IRenderContext.DrawTriangle3D | ( | IVertex | first,
|  | IVertex | second,
|  | IVertex | third
| ) |  |

Draws single triangle specified by three vertices.

This is slow, use only in special circumstances (debug rendering)

Implemented in VisimBox.Renderer.RenderContext, and VisimRenderGL.GLRenderContext.

void VisimBox.Renderer.IRenderContext.EndFrame | ( |  | ) |

Finished rendering frame and shows it.

Implemented in VisimBox.Renderer.RenderContext, and VisimRenderGL.GLRenderContext.

void VisimBox.Renderer.IRenderContext.FinishRenderQueue | ( |  | ) |

Finishes rendering queue (renders all remaining items in the queue including sorted alpha items)

Implemented in VisimBox.Renderer.RenderContext.

System.Drawing.Bitmap VisimBox.Renderer.IRenderContext.GetScreenShot | ( |  | ) |

Grabs actual content of the render context and converts it to bitmap.

Returns:
  BMP containg current output on the render context

Implemented in VisimBox.Renderer.RenderContext, and VisimRenderGL.GLRenderContext.

void VisimBox.Renderer.IRenderContext.RenderFrame | ( |  | ) |

Renders frame in standard way (StartFrame and then EndFrame with associated callbacks)

Implemented in VisimBox.Renderer.RenderContext, and VisimRenderGL.GLRenderContext.

void VisimBox.Renderer.IRenderContext.RenderGeometry | ( | IndexedLines | geo,
|  | int | subset = `0`
| ) |  |

Renders geometry object - Indexed list of points.

Parameters:

  geo | Geometry object

Renders from the vertexarray, might be much faster then direct rendering, but still slower then using vertex buffers

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.RenderGeometry | ( | LineList | geo | ) |

Renders geometry object - List of lines.

Parameters:

  geo | Geometry object

Renders from the vertexarray, might be much faster then direct rendering, but still slower then using vertex buffers

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.RenderGeometry | ( | IndexedQuads | geo,
|  | int | subset = `0`
| ) |  |

Renders geometry object - Indexed quad mesh.

Parameters:

  geo | Geometry object

Renders from the vertexarray, might be much faster then direct rendering, but still slower then using vertex buffers

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.RenderGeometry | ( | PolyLine | geo | ) |

Renders geometry object - PolyLine.

Parameters:

  geo | Geometry object

Renders from the vertexarray, might be much faster then direct rendering, but still slower then using vertex buffers

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.RenderGeometry | ( | IGeometry | geometry | ) |

Renders generic geometry object - uses conversion routines from the object, will be very slow if overused!

Parameters:

  geo | Geometry object

Renders from the vertexarray, might be much faster then direct rendering, but still slower then using vertex buffers

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.RenderGeometry | ( | QuadList | geo | ) |

Renders geometry object - List of quads.

Parameters:

  geo | Geometry object

Renders from the vertexarray, might be much faster then direct rendering, but still slower then using vertex buffers

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.RenderGeometry | ( | IndexedMesh | geo,
|  | int | subset = `0`
| ) |  |

Renders geometry object - Indexed triangle mesh.

Parameters:

  geo | Geometry object

Renders from the vertexarray, might be much faster then direct rendering, but still slower then using vertex buffers

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.RenderGeometry | ( | Point3DList | geo | ) |

Renders geometry object - List of points.

Parameters:

  geo | Geometry object

Renders from the vertexarray, might be much faster then direct rendering, but still slower then using vertex buffers

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.RenderGeometry | ( | IndexedGeo | geo,
|  | int | subset = `0`
| ) |  |

Renders geometry object - generic indexed geometry.

Parameters:

  geo | Geometry object

Renders from the vertexarray, might be much faster then direct rendering, but still slower then using vertex buffers

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.RenderGeometry | ( | TriangleList | geo | ) |

Renders geometry object - List of triangles.

Parameters:

  geo | Geometry object

Renders from the vertexarray, might be much faster then direct rendering, but still slower then using vertex buffers

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.RenderIndexedMesh | ( | IVertexArray | varray,
|  | int[] | indices,
|  | PrimitiveTypes | type,
|  | int | startindex = `0`,
|  | int | count = `0`
| ) |  |

Renders indexed mesh from vertex array.

Parameters:

  varray | Vertex array with vertices (should be VertexArray, not VertexList)
  indices | Indices for elements
  type | Type of primitive in indexed mesh (valid are Poins, Lines, Triangles and Quads)
  startindex | First vertice to render
  count | Count of vertices to draw (if zero, all remaining elements from starting index will be drawn

Rendering from system memory is (depending on the implementation, applies for openGL) much faster then direct rendering, but still slower then vertex buffers.

Implemented in VisimBox.Renderer.RenderContext, and VisimRenderGL.GLRenderContext.

void VisimBox.Renderer.IRenderContext.RenderIndexedMesh | ( | IVertexBuffer | vertices,
|  | int[] | indices,
|  | PrimitiveTypes | type,
|  | int | startindex = `0`,
|  | int | count = `0`
| ) |  |

Renders indexed mesh from vertex and index buffer.

Parameters:

  vertices | Vertex buffer
  indices | Index buffer
  type | Primitive type
  startindex | starting index
  count | Number of elements

Implemented in VisimBox.Renderer.RenderContext, and VisimRenderGL.GLRenderContext.

void VisimBox.Renderer.IRenderContext.RenderIndexedMesh | ( | IVertexBuffer | vertices,
|  | IIndexBuffer | indices,
|  | PrimitiveTypes | type,
|  | int | startindex = `0`,
|  | int | count = `0`
| ) |  |

Renders indexed mesh from vertex and index buffer.

Parameters:

  vertices | Vertex buffer
  indices | Index buffer
  type | Primitive type
  startindex | starting index
  count | Number of elements

Implemented in VisimBox.Renderer.RenderContext, and VisimRenderGL.GLRenderContext.

void VisimBox.Renderer.IRenderContext.RenderLine | ( | IVertexArray | varray,
|  | int | startindex = `0`,
|  | int | count = `0`
| ) |  |

Renders polyline from vertex array.

Parameters:

  varray | Vertex array with vertices (should be VertexArray, not VertexList)
  startindex | First vertice to render
  count | Count of vertices to draw (if zero, all remaining elements from starting index will be drawn

Rendering from system memory is (depending on the implementation, applies for openGL) much faster then direct rendering, but still slower then vertex buffers.

Implemented in VisimBox.Renderer.RenderContext, and VisimRenderGL.GLRenderContext.

void VisimBox.Renderer.IRenderContext.RenderLines | ( | IVertexArray | varray,
|  | int | startindex = `0`,
|  | int | count = `0`
| ) |  |

Renders lines from vertex array.

Parameters:

  varray | Vertex array with vertices (should be VertexArray, not VertexList)
  startindex | First vertice to render
  count | Count of vertices to draw (if zero, all remaining elements from starting index will be drawn

Rendering from system memory is (depending on the implementation, applies for openGL) much faster then direct rendering, but still slower then vertex buffers.

Implemented in VisimBox.Renderer.RenderContext, and VisimRenderGL.GLRenderContext.

void VisimBox.Renderer.IRenderContext.RenderNodes | ( | Node | scene | ) |

Renders spefified node hierarchy.

Parameters:

  scene | Nodes to render

Hierarchically travels the whole scene - calling OnRender for each visible node implementing IRenderable.

void VisimBox.Renderer.IRenderContext.RenderPoints | ( | IVertexArray | varray,
|  | int | startindex = `0`,
|  | int | count = `0`
| ) |  |

Renders points from vertex array.

Parameters:

  varray | Vertex array with vertices (should be VertexArray, not VertexList)
  startindex | First vertice to render
  count | Count of vertices to draw (if zero, all remaining elements from starting index will be drawn

Rendering from system memory is (depending on the implementation, applies for openGL) much faster then direct rendering, but still slower then vertex buffers.

Implemented in VisimBox.Renderer.RenderContext, and VisimRenderGL.GLRenderContext.

void VisimBox.Renderer.IRenderContext.RenderPoly | ( | IVertexArray | varray,
|  | int | startindex = `0`,
|  | int | count = `0`
| ) |  |

Renders polygon from vertex array.

Parameters:

  varray | Vertex array with vertices (should be VertexArray, not VertexList)
  startindex | First vertice to render
  count | Count of vertices to draw (if zero, all remaining elements from starting index will be drawn

Rendering from system memory is (depending on the implementation, applies for openGL) much faster then direct rendering, but still slower then vertex buffers.

Implemented in VisimBox.Renderer.RenderContext, and VisimRenderGL.GLRenderContext.

void VisimBox.Renderer.IRenderContext.RenderQuads | ( | IVertexArray | varray,
|  | int | startindex = `0`,
|  | int | count = `0`
| ) |  |

Renders quads from vertex array.

Parameters:

  varray | Vertex array with vertices (should be VertexArray, not VertexList)
  startindex | First vertice to render
  count | Count of vertices to draw (if zero, all remaining elements from starting index will be drawn

Rendering from system memory is (depending on the implementation, applies for openGL) much faster then direct rendering, but still slower then vertex buffers.

Implemented in VisimBox.Renderer.RenderContext, and VisimRenderGL.GLRenderContext.

void VisimBox.Renderer.IRenderContext.RenderTriangles | ( | IVertexArray | varray,
|  | int | startindex = `0`,
|  | int | count = `0`
| ) |  |

Renders triangles from vertex array.

Parameters:

  varray | Vertex array with vertices (should be VertexArray, not VertexList)
  startindex | First vertice to render
  count | Count of vertices to draw (if zero, all remaining elements from starting index will be drawn

Rendering from system memory is (depending on the implementation, applies for openGL) much faster then direct rendering, but still slower then vertex buffers.

Implemented in VisimBox.Renderer.RenderContext, and VisimRenderGL.GLRenderContext.

void VisimBox.Renderer.IRenderContext.RenderVertexBuffer | ( | IVertexBuffer | vertices,
|  | PrimitiveTypes | type,
|  | int | startindex = `0`,
|  | int | count = `0`
| ) |  |

Render vertex buffer as specified type of primitive (can't be used for indexed meshes!)

Parameters:

  vertices | Vertex buffer
  type | Primitive type
  startindex | starting index
  count | Number of elements

Implemented in VisimBox.Renderer.RenderContext, and VisimRenderGL.GLRenderContext.

void VisimBox.Renderer.IRenderContext.SaveScreenShot | ( | string | filename = `null`,
|  | string | extension = `null`
| ) |  |

Saves screenshot with specified name, uses GetScreenShot()

Parameters:

  filename | filename to save, if null, creates file ScreenshotDATE-TIME.jpg
  extension | can be set to png, jpg or bmp to override format from the filename (or if filename is specified without extension)

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.SetColor | ( | System.Drawing.Color | col | ) |

Sets main rendering color (especially for 2d rendering)

Parameters:

  col | Color

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.SetColor | ( | ColorByte | col | ) |

Sets main rendering color (especially for 2d rendering)

Parameters:

  col | Color

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.SetColor | ( | ref ColorByte | col | ) |

Sets main rendering color (especially for 2d rendering)

Parameters:

  col | Color

Implemented in VisimBox.Renderer.RenderContext, and VisimRenderGL.GLRenderContext.

void VisimBox.Renderer.IRenderContext.SetTransformation | ( | ref Matrix4 | mat | ) |

Sets model transformation (without camera transformation)

Parameters:

  mat |

Implemented in VisimBox.Renderer.RenderContext, and VisimRenderGL.GLRenderContext.

void VisimBox.Renderer.IRenderContext.SetTransformation | ( | Matrix4 | mat | ) |

Sets model transformation (without camera transformation)

Parameters:

  mat |

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.Start2DRender | ( |  | ) |

Sets renderer to 2d context, all 2d rendering calls should be done after this call!

Implemented in VisimBox.Renderer.RenderContext, and VisimRenderGL.GLRenderContext.

void VisimBox.Renderer.IRenderContext.StartFrame | ( |  | ) |

Starts rendering frame.

Implemented in VisimBox.Renderer.RenderContext, and VisimRenderGL.GLRenderContext.

void VisimBox.Renderer.IRenderContext.StartRenderingQueue | ( |  | ) |

Starts rendering queue (allows adding new items to render queue. If renderer uses multithreading, queue will be rendered as soon as some queue item will be added, except alpha values.

Implemented in VisimBox.Renderer.RenderContext.

void VisimBox.Renderer.IRenderContext.Stop2DRender | ( |  | ) |

Returns renderer to previous (3d) rendering state from the 2d renderer.

Implemented in VisimBox.Renderer.RenderContext, and VisimRenderGL.GLRenderContext.

## Property Documentation

int VisimBox.Renderer.IRenderContext.CurrentFPS`[get]`

Returns current rendering frames per second for this context.

Implemented in VisimBox.Renderer.RenderContext.

Texture VisimBox.Renderer.IRenderContext.CurrentTexture`[get, set]`

Currently selected texture.

Implemented in VisimBox.Renderer.RenderContext, and VisimRenderGL.GLRenderContext.

Vector3 VisimBox.Renderer.IRenderContext.DebugLine1`[get, set]`

Implemented in VisimBox.Renderer.RenderContext.

Vector3 VisimBox.Renderer.IRenderContext.DebugLine2`[get, set]`

Implemented in VisimBox.Renderer.RenderContext.

Vector3 VisimBox.Renderer.IRenderContext.DebugPoint`[get, set]`

Implemented in VisimBox.Renderer.RenderContext.

bool VisimBox.Renderer.IRenderContext.Fog`[get, set]`

Enables / disables fog drawing.

Implemented in VisimBox.Renderer.RenderContext, and VisimRenderGL.GLRenderContext.

ColorByte VisimBox.Renderer.IRenderContext.FogColor`[get, set]`

Color of the fog.

Implemented in VisimBox.Renderer.RenderContext, and VisimRenderGL.GLRenderContext.

float VisimBox.Renderer.IRenderContext.FogDensity`[get, set]`

Density of the fog.

Implemented in VisimBox.Renderer.RenderContext, and VisimRenderGL.GLRenderContext.

ICamera VisimBox.Renderer.IRenderContext.MainCamera`[get, set]`

Returns pointer to the main camera (camera in main viewport)

Implemented in VisimBox.Renderer.RenderContext.

IRenderer VisimBox.Renderer.IRenderContext.Renderer`[get]`

Main renderer for this context.

Implemented in VisimBox.Renderer.RenderContext.

RenderContextSettings VisimBox.Renderer.IRenderContext.Settings`[get]`

Settings of the context.

Implemented in VisimBox.Renderer.RenderContext.

bool VisimBox.Renderer.IRenderContext.ShowFPS`[get, set]`

Show fps on screen?

Implemented in VisimBox.Renderer.RenderContext.

bool VisimBox.Renderer.IRenderContext.ZBufferUsing`[get, set]`

Use to directly change using of the zbuffer.

Implemented in VisimBox.Renderer.RenderContext, and VisimRenderGL.GLRenderContext.

## Event Documentation

RendererEvent VisimBox.Renderer.IRenderContext.FrameEnd

Called on the end of the frame before showing results of the rendering.

Implemented in VisimBox.Renderer.RenderContext.

RendererEvent VisimBox.Renderer.IRenderContext.FrameStart

Called on the framestart before any rendering / clearing starts.

Implemented in VisimBox.Renderer.RenderContext.

The documentation for this interface was generated from the following file:

- IRenderContext.cs

All Classes Namespaces Files Functions Variables Enumerations Properties Events